Bullet Collision Detection & Physics Library: btDeformableLinearElasticityForce Class Reference

Bullet Collision Detection & Physics Library

Public Types | Public Member Functions | Public Attributes | List of all members
btDeformableLinearElasticityForce Class Reference

`#include <btDeformableLinearElasticityForce.h>`

Inheritance diagram for btDeformableLinearElasticityForce:
[legend]
Collaboration diagram for btDeformableLinearElasticityForce:
[legend]

## Public Types
typedef btAlignedObjectArray< btVector3 > | TVStack
Public Types inherited from btDeformableLagrangianForce
typedef btAlignedObjectArray< btVector3 > | TVStack

## Public Member Functions
| btDeformableLinearElasticityForce ()
| btDeformableLinearElasticityForce (btScalar mu, btScalar lambda, btScalar damping=0.05)
virtual void | addScaledForces (btScalar scale, TVStack &force)
virtual void | addScaledExplicitForce (btScalar scale, TVStack &force)
virtual void | addScaledDampingForce (btScalar scale, TVStack &force)
virtual double | totalElasticEnergy (btScalar dt)
virtual double | totalDampingEnergy (btScalar dt)
double | elasticEnergyDensity (const btSoftBody::TetraScratch &s)
virtual void | addScaledElasticForce (btScalar scale, TVStack &force)
virtual void | addScaledDampingForceDifferential (btScalar scale, const TVStack &dv, TVStack &df)
virtual void | addScaledElasticForceDifferential (btScalar scale, const TVStack &dx, TVStack &df)
void | firstPiola (const btSoftBody::TetraScratch &s, btMatrix3x3 &P)
void | firstPiolaDifferential (const btSoftBody::TetraScratch &s, const btMatrix3x3 &dF, btMatrix3x3 &dP)
void | firstPiolaDampingDifferential (const btSoftBody::TetraScratch &s, const btMatrix3x3 &dF, btMatrix3x3 &dP)
virtual btDeformableLagrangianForceType | getForceType ()
Public Member Functions inherited from btDeformableLagrangianForce
| btDeformableLagrangianForce ()
virtual | ~btDeformableLagrangianForce ()
virtual void | reinitialize (bool nodeUpdated)
virtual int | getNumNodes ()
virtual void | addSoftBody (btSoftBody *psb)
virtual void | setIndices (const btAlignedObjectArray< btSoftBody::Node * > *nodes)
virtual btMatrix3x3 | Ds (int id0, int id1, int id2, int id3, const TVStack &dx)
virtual btMatrix3x3 | DsFromVelocity (const btSoftBody::Node *n0, const btSoftBody::Node *n1, const btSoftBody::Node *n2, const btSoftBody::Node *n3)
virtual void | testDerivative ()
virtual void | testHessian ()
virtual double | totalEnergy (btScalar dt)

## Public Attributes
btScalar | m_mu
btScalar | m_lambda
btScalar | m_mu_damp
btScalar | m_lambda_damp
Public Attributes inherited from btDeformableLagrangianForce
btAlignedObjectArray< btSoftBody * > | m_softBodies
const btAlignedObjectArray< btSoftBody::Node * > * | m_nodes

## Detailed Description

Definition at line 21 of file btDeformableLinearElasticityForce.h.

## Member Typedef Documentation

## ◆ TVStack

typedef btAlignedObjectArray<btVector3> btDeformableLinearElasticityForce::TVStack

Definition at line 24 of file btDeformableLinearElasticityForce.h.

## Constructor & Destructor Documentation

## ◆ btDeformableLinearElasticityForce() [1/2]

btDeformableLinearElasticityForce::btDeformableLinearElasticityForce | ( |  | ) |
| inline

Definition at line 27 of file btDeformableLinearElasticityForce.h.

## ◆ btDeformableLinearElasticityForce() [2/2]

btDeformableLinearElasticityForce::btDeformableLinearElasticityForce | ( | btScalar | mu,
|  | btScalar | lambda,
|  | btScalar | damping = `0.05`
| ) |  |
| inline

Definition at line 34 of file btDeformableLinearElasticityForce.h.

## Member Function Documentation

## ◆ addScaledDampingForce()

virtual void btDeformableLinearElasticityForce::addScaledDampingForce | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 52 of file btDeformableLinearElasticityForce.h.

## ◆ addScaledDampingForceDifferential()

virtual void btDeformableLinearElasticityForce::addScaledDampingForceDifferential | ( | btScalar | scale,
|  | const TVStack & | dv,
|  | TVStack & | df
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 227 of file btDeformableLinearElasticityForce.h.

## ◆ addScaledElasticForce()

virtual void btDeformableLinearElasticityForce::addScaledElasticForce | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Definition at line 159 of file btDeformableLinearElasticityForce.h.

## ◆ addScaledElasticForceDifferential()

virtual void btDeformableLinearElasticityForce::addScaledElasticForceDifferential | ( | btScalar | scale,
|  | const TVStack & | dx,
|  | TVStack & | df
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 271 of file btDeformableLinearElasticityForce.h.

## ◆ addScaledExplicitForce()

virtual void btDeformableLinearElasticityForce::addScaledExplicitForce | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 46 of file btDeformableLinearElasticityForce.h.

## ◆ addScaledForces()

virtual void btDeformableLinearElasticityForce::addScaledForces | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 40 of file btDeformableLinearElasticityForce.h.

## ◆ elasticEnergyDensity()

double btDeformableLinearElasticityForce::elasticEnergyDensity | ( | const btSoftBody::TetraScratch & | s | ) |
| inline

Definition at line 149 of file btDeformableLinearElasticityForce.h.

## ◆ firstPiola()

void btDeformableLinearElasticityForce::firstPiola | ( | const btSoftBody::TetraScratch & | s,
|  | btMatrix3x3 & | P
| ) |  |
| inline

Definition at line 311 of file btDeformableLinearElasticityForce.h.

## ◆ firstPiolaDampingDifferential()

void btDeformableLinearElasticityForce::firstPiolaDampingDifferential | ( | const btSoftBody::TetraScratch & | s,
|  | const btMatrix3x3 & | dF,
|  | btMatrix3x3 & | dP
| ) |  |
| inline

Definition at line 328 of file btDeformableLinearElasticityForce.h.

## ◆ firstPiolaDifferential()

void btDeformableLinearElasticityForce::firstPiolaDifferential | ( | const btSoftBody::TetraScratch & | s,
|  | const btMatrix3x3 & | dF,
|  | btMatrix3x3 & | dP
| ) |  |
| inline

Definition at line 320 of file btDeformableLinearElasticityForce.h.

## ◆ getForceType()

virtual btDeformableLagrangianForceType btDeformableLinearElasticityForce::getForceType | ( |  | ) |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 334 of file btDeformableLinearElasticityForce.h.

## ◆ totalDampingEnergy()

virtual double btDeformableLinearElasticityForce::totalDampingEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented from btDeformableLagrangianForce.

Definition at line 116 of file btDeformableLinearElasticityForce.h.

## ◆ totalElasticEnergy()

virtual double btDeformableLinearElasticityForce::totalElasticEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented from btDeformableLagrangianForce.

Definition at line 95 of file btDeformableLinearElasticityForce.h.

## Member Data Documentation

## ◆ m_lambda

btScalar btDeformableLinearElasticityForce::m_lambda

Definition at line 25 of file btDeformableLinearElasticityForce.h.

## ◆ m_lambda_damp

btScalar btDeformableLinearElasticityForce::m_lambda_damp

Definition at line 26 of file btDeformableLinearElasticityForce.h.

## ◆ m_mu

btScalar btDeformableLinearElasticityForce::m_mu

Definition at line 25 of file btDeformableLinearElasticityForce.h.

## ◆ m_mu_damp

btScalar btDeformableLinearElasticityForce::m_mu_damp

Definition at line 26 of file btDeformableLinearElasticityForce.h.

The documentation for this class was generated from the following file:

- btDeformableLinearElasticityForce.h